import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.print.DocFlavor.URL;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.BevelBorder;
import javax.swing.table.TableColumnModel;
import javax.swing.UIManager;
import javax.swing.JTextField;
import javax.swing.JLabel;
import java.awt.Toolkit;

public class mainFrame {

	private JFrame frmLeastSquaresMulty;
	
	 int samples = 0;
     int dataLength = 0;
     int features = 5;
     double[][] fOfX;
     TData data;    
     TDataGrid tableData;
     private JTable tDataTable;
     private JTextField tfX1;
     private JTextField tfX2;
     private JTextField tfX3;
     private JTextField tfX4;
     private JTextField tfX5;
     private JTextField tfX0;
     private JTextField tfY0;
     private JTextField tfZ0;
     
     private void calculate()
     {
    	 int i, j, k;
         
         double xRes;
         double y;
         double z;
         double[] tempD = new double[features];

         //TMatrix m = new TMatrix(features);
         double[][] m = new double[features][features];
         double[] d = new double[features];
         double[] x = new double[features];
         TGivens givens = new TGivens(features, m, d);
   
         // fill the matrix
         for (i = 0; i < features; i++)
         {
             for (j = 0; j < features; j++)
             {
                 for (k = 0; k < samples; k++)
                     m[j][i] = m[j][i] + fOfX[k][i] * fOfX[k][j];
             }
             for (k = 0; k < samples; k++)
             {
            	 double[] val = data.values.get(k);
                 d[i] = d[i] + val[2] * fOfX[k][i];
             }
         }

         // solve the matrix equation by Givens transformations
         givens.RunGivens();
         x = givens.SolveRMatrix();
        
         // display the results
         tfX1.setText(Double.toString(Math.round(x[0]*10000)/10000.0));
         tfX2.setText(Double.toString(Math.round(x[1]*10000)/10000.0));
         tfX3.setText(Double.toString(Math.round(x[2]*10000)/10000.0));
         tfX4.setText(Double.toString(Math.round(x[3]*10000)/10000.0));
         tfX5.setText(Double.toString(Math.round(x[4]*10000)/10000.0));
       
         if ((x[1] != 0) && (x[3] != 0))
         {
             xRes = -x[0] / x[1] / 2;
             y = -x[2] / x[3] / 2;
             z = xRes * x[0] + xRes * xRes * x[1] + y * x[2] + y * y * x[3] + x[4];
             
             tfX0.setText(Double.toString(Math.round(xRes*100000)/100000.0));
             tfY0.setText(Double.toString(Math.round(y*100000)/100000.0));
             tfZ0.setText(Double.toString(Math.round(z*100000)/100000.0));
 
             for (i = 0; i < samples; i++)
             {
            	 tempD = data.values.get(i);
                 xRes = tempD[0];
                 y = tempD[1];
                 z = xRes * x[0] + xRes * xRes * x[1] + y * x[2] + y * y * x[3] + x[4];
                 String str = Double.toString(Math.round(z*10000)/10000.0);
                 tableData.setValueAt(str, i, 3);
                 if (z != 0)
                 {
                	 str = Double.toString(Math.round( (z - tempD[2]) / z * 100 * 1000)/1000.0);
                	 tableData.setValueAt(str, i, 4);
                 }
                  
             }
         }
        // else
         //    MessageBox.Show("No minimum found for Z");
     }
     
     
     /**
 	 * Launch the application.
 	 */
 	public static void main(String[] args) {
 		EventQueue.invokeLater(new Runnable() {
 			public void run() {
 				try {
 					mainFrame window = new mainFrame();
 					window.frmLeastSquaresMulty.setVisible(true);
 				} catch (Exception e) {
 					e.printStackTrace();
 				}
 			}
 		});
 	}


	/**
	 * Create the application.
	 */
	public mainFrame() {
		int i, j;
		initialize();
		
		fOfX = new double[samples][features];
        double[] tempD = new double[features];
        for (i = 0; i < samples; i++)
        {
            tempD =  data.values.get(i);
            fOfX[i][0] = tempD[0];
            fOfX[i][1] = tempD[0] * tempD[0];

            fOfX[i][2] = tempD[1];
            fOfX[i][3] = tempD[1] * tempD[1];
            fOfX[i][4] = 1.0;
        }
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		int i,j;
		frmLeastSquaresMulty = new JFrame();
		frmLeastSquaresMulty.setTitle("Least squares multy");
		frmLeastSquaresMulty.setIconImage(Toolkit.getDefaultToolkit().getImage(mainFrame.class.getResource("/Ressource/Icon.png")));
		frmLeastSquaresMulty.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmLeastSquaresMulty.setBounds(100, 100, 699, 418);
		frmLeastSquaresMulty.getContentPane().setLayout(null);
		String str = System.getProperty("java.class.path");
		data = new TData();
		data.readData(str + "\\data.csv");
		samples = data.values.size();
		tableData = new TDataGrid(features, samples);
		for (i = 0; i < samples; i++)
        {
			double[] val = data.values.get(i);
			for( j=0; j < val.length; j++)
			{
				String s = Double.toString(Math.round(val[j]*10000)/10000.0);
			tableData.setValueAt(s, i, j);
			}
        }        
		tDataTable = new JTable(tableData);
		tDataTable.setRowHeight(25);
		tDataTable.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		tDataTable.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tDataTable.setBounds(10, 11, 390, 120);
		frmLeastSquaresMulty.getContentPane().add(tDataTable);
		JScrollPane scroll = new JScrollPane(tDataTable);
	    scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		frmLeastSquaresMulty.getContentPane().add(scroll);
	    scroll.setBounds(10, 10, 663, 251);
	    TableColumnModel columnModel = tDataTable.getColumnModel();
	    columnModel.getColumn(0).setHeaderValue("x");
	    columnModel.getColumn(1).setHeaderValue("y");
	    columnModel.getColumn(2).setHeaderValue("z");
	    columnModel.getColumn(3).setHeaderValue("f(x,y)");
	    columnModel.getColumn(4).setHeaderValue("dev[%]");
	    JButton btCalc = new JButton("Calculate");
		btCalc.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				calculate();
			}
		});
		btCalc.setBounds(561, 284, 112, 72);
		frmLeastSquaresMulty.getContentPane().add(btCalc);
		
		tfX1 = new JTextField();
		tfX1.setColumns(10);
		tfX1.setBounds(102, 285, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX1);
		
		tfX2 = new JTextField();
		tfX2.setColumns(10);
		tfX2.setBounds(174, 285, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX2);
		
		tfX3 = new JTextField();
		tfX3.setColumns(10);
		tfX3.setBounds(246, 285, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX3);
		
		tfX4 = new JTextField();
		tfX4.setColumns(10);
		tfX4.setBounds(318, 285, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX4);
		
		tfX5 = new JTextField();
		tfX5.setColumns(10);
		tfX5.setBounds(390, 285, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX5);
		
		tfX0 = new JTextField();
		tfX0.setColumns(10);
		tfX0.setBounds(102, 326, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfX0);
		
		tfY0 = new JTextField();
		tfY0.setColumns(10);
		tfY0.setBounds(246, 326, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfY0);
		
		tfZ0 = new JTextField();
		tfZ0.setColumns(10);
		tfZ0.setBounds(390, 326, 62, 30);
		frmLeastSquaresMulty.getContentPane().add(tfZ0);
		
		JLabel lblNewLabel = new JLabel("c1...c5");
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblNewLabel.setBounds(30, 285, 62, 26);
		frmLeastSquaresMulty.getContentPane().add(lblNewLabel);
		
		JLabel lblX = new JLabel("x_0");
		lblX.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblX.setBounds(52, 326, 40, 26);
		frmLeastSquaresMulty.getContentPane().add(lblX);
		
		JLabel lblY = new JLabel("y_0");
		lblY.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblY.setBounds(196, 326, 40, 26);
		frmLeastSquaresMulty.getContentPane().add(lblY);
		
		JLabel lblZ = new JLabel("z_0");
		lblZ.setFont(new Font("Tahoma", Font.PLAIN, 16));
		lblZ.setBounds(349, 326, 40, 26);
		frmLeastSquaresMulty.getContentPane().add(lblZ);
		
	}
}
